package net.weasel.HelpCenter;

import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.util.Arrays;
import java.util.Random;
import java.util.Scanner;
import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.Event;
import org.bukkit.event.Event.Priority;
import org.bukkit.event.Event.Type;
import org.bukkit.event.player.PlayerEvent;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.plugin.PluginManager;
import java.net.*;

public class HelpCenter extends JavaPlugin 
{
	public static long rSeed = java.util.GregorianCalendar.MILLISECOND;
	public static boolean hasWelcomeFile = false;
	public static Random gen = new java.util.Random(rSeed);
	public static int item;
	
	private final HelpCenterListener playerListener = new HelpCenterListener(this);
	public static final String DATE_FMT = "yyyy-MM-dd HH:mm:ss";
	
	@Override
	public void onDisable() 
	{
		logOutput("HelpCenter disabled.");
	}

	@Override
	public void onEnable() 
	{
		initHelpCenter();
	}

	public void onPlayerJoin(PlayerEvent event)
	{
		Player player = event.getPlayer();
		
		if( event.getType() == Type.PLAYER_JOIN )
		{
			try 
			{
				String result = HelpCenter.getHelpFile(player, "welcome");
				CharSequence chk = "No help found for ";
				
				if( result.contains(chk) != true )
				{
					player.sendMessage( result );
				}
			} 
			
			catch (IOException e) 
			{
				e.printStackTrace();
			}
		}
	}

	public boolean onCommand(CommandSender sender, Command command, String commandLabel, String[] args) 
    {
    	Player player = (Player) sender;
    	String pCommand = command.getName().toLowerCase();
    	String contents = "";
    	boolean retVal = false;

    	if((pCommand.equals("help")) || (pCommand.equals("?")))
		{			
    		if( args.length > 0 )
    		{
    			try 
    			{
    				contents = getHelpFile( player, arrayToString(args, " ") );
    				retVal = true;
     			} 
    			catch (IOException e) 
    			{
					contents = "#!RUnable to load helpfile.#!w";
    				e.printStackTrace();
    			}
    		}
    		else    			
			{
				try 
				{
					contents = getHelpFile( player, "HCdefault" );
					retVal = true;
				} 
				catch (IOException e) 
				{
					contents = "#!RUnable to load helpfile.#!w";
					e.printStackTrace();
				}
			}
		}
    	
    	try 
    	{
			processHelp( player, contents, arrayToString(args," ") );
		}
    	catch (IOException e) 
    	{
			player.sendMessage( cColour( "#!RUnable to load helpfile.#!w" ) );
			e.printStackTrace();
		}
    	
		return( retVal );
    }

	public static String cColour( String message )
	{
		CharSequence cChk = null;
		String temp = null;
		String[] Colours = { "#!k", "#!b", "#!g", "#!c", "#!r", "#!m", "#!y", "#!w", 
							 "#!K", "#!B", "#!G", "#!C", "#!R", "#!M", "#!Y", "#!W" };
		
		ChatColor[] cCode = { ChatColor.BLACK, ChatColor.DARK_BLUE, ChatColor.DARK_GREEN,
				           ChatColor.DARK_AQUA, ChatColor.DARK_RED, ChatColor.DARK_PURPLE,
				           ChatColor.GOLD, ChatColor.GRAY, ChatColor.DARK_GRAY,
				           ChatColor.BLUE, ChatColor.GREEN, ChatColor.AQUA, ChatColor.RED,
				           ChatColor.LIGHT_PURPLE, ChatColor.YELLOW, ChatColor.WHITE };
		
		for( int x = 0; x < Colours.length; x++ )
		{
			cChk = Colours[x];
			
			if( message.contains(cChk))
			{
				temp = message.replace(cChk, cCode[x].toString() );
				message = temp;
			}
			
		}
		
		return message;
		
	}
	
	public static class Dir implements FileFilter
	{
		private final String[] fileEx = new String[] { "txt" };
		
		static File[] getFiles(File path)
		{
			File files[];
			FileFilter filter = null;
			
			files = path.listFiles(filter);
		
			Arrays.sort(files);
			
			return( files );
		}

		@Override
		public boolean accept(File file) 
		{
			for( String extension : fileEx )
			{
				if( file.getName().toLowerCase().endsWith(extension))
				{
					return true;
				}
			}
			return false;
		}
	}
	
	public static void logOutput(String output)
	{
		System.out.println( "[HelpCenter] " + output );
	}

	public void fileLocationUpgrade()
	{
		logOutput( "Checking file locations for upgrade availability.." );
		
		File path = new File("plugins/HelpCenter");
		
		if( path.exists() == true ) 
		{
			logOutput( "Location OK." );
			return;
		}
		
		path = new File("HelpCenter");
			
		if( path.exists() == true )
		{
			path = new File("plugins/HelpCenter");
				
			if( path.exists() == false )
			{
				logOutput("Directory 'plugins/HelpCenter' does not exist.");
				
				path = new File( "HelpCenter" );
					
				if( path.exists() == true )
				{
					File newPath = new File("plugins/HelpCenter");
					path.renameTo(newPath);
					logOutput( "HelpCenter folder moved to plugins/HelpCenter." );
				}
				else
					logOutput( "Unable to find any HelpCenter folder!" );
			}
			
		}
	}
	
	public void initHelpCenter()
	{
		fileLocationUpgrade();
		
		PluginManager pm = getServer().getPluginManager();		
		pm.registerEvent(Event.Type.PLAYER_JOIN, this.playerListener, Priority.Normal,this );
		PluginDescriptionFile pdfFile = this.getDescription();
		Plugin plugin = pm.getPlugin("HelpCenter");
		
		File path = new File("plugins/HelpCenter");
		
		if( path.exists() == false )
		{
			logOutput("Attempting to create new folder plugins/HelpCenter..");
			
			if( path.mkdir() == true )
			{
				logOutput("Created successfully.");
			}
			else
			{
				logOutput("Unable to create directory! Do you have write permission?");
				pm.disablePlugin(plugin);
			}
		}

		logOutput( pdfFile.getName() + " v" + pdfFile.getVersion() + " loaded.");
		
	}
	
	public static String getHelpFile(Player who, String which) throws IOException
	{
		CharSequence checkStr = "../";
		File hFile = null;
		String retVal = "";
		String player = who.getName();
		
		if( which == "" )
		{
			return( "" );
		}
		
		if( which != "HCdefault" )
		{
			hFile = new File("plugins/HelpCenter/" + which.toLowerCase() + ".txt");
		}
		else
		{
			hFile = new File("plugins/HelpCenter/" + which + ".txt");
		}
		
		if( which.contains(checkStr) == true )
		{
			logOutput( player + " tried to cheat the HelpCenter! : " + which.toString() );
			retVal = cColour( "#!RNo help found for #!Y" + which + "#!R.#!w" );
		}
		
		if( hFile.exists() == false )
		{
			logOutput( player + " tried to view a nonexistent help file: " + which + ".txt" );
			retVal = cColour( "#!RNo help found for #!Y" + which + "#!R.#!w" );
		}
		else
		{
			byte[] buf = new byte[(int)hFile.length()];
			BufferedInputStream fr = null;
			
			try
			{
				fr = new BufferedInputStream(new FileInputStream(hFile.toString()));
				fr.read(buf);
			}
			finally
			{
				if( fr != null ) try { fr.close(); } catch (IOException ignored) { }
			}
			
			retVal = new String(buf);
			
		}
		
		return retVal;
	}
	
	public static String fetchWebHelp(String who, String address) throws MalformedURLException
	{
		logOutput( "Fetching help URL for " + who + ": " + address );
		String result = null;
		URLConnection fConn = null;
		
		try
		{
			fConn = new URL(address).openConnection();
			Scanner fSc = new Scanner(fConn.getInputStream());
			fSc.useDelimiter("\\Z");
			result = fSc.next();
		}
		catch (Exception e)
		{
			logOutput( "Unable to fetch web help URL: " + address );
			return( "Unable to fetch web help." );
		}
		
		return( result );
	}

    public static String arrayToString(String[] a, String separator) 
    {
        String result = "";
        
        if (a.length > 0) 
        {
            result = a[0];    // start with the first element
            for (int i=1; i<a.length; i++) {
                result = result + separator + a[i];
            }
        }
        
        return result;
    }
        
    public static void processHelp( Player who, String helpData, String topic ) throws IOException
    {
    	CharSequence chkStr = "";
    	
    	helpData.replace( "\r", "" );
    	
    	chkStr = "#!HELP";
		
    	if( helpData.contains( chkStr ) )
    	{
    		String[] helps = helpData.split( (String) chkStr, 0 );
    		
    		int X = 0;
    		
    		while( X < 1 ) { X = gen.nextInt(helps.length); }
    	
    		String helpItem = helps[X];
    		
    		if( helpItem.length() > 2)
    		{
        		chkStr = "\n";
            	
        		if( helpItem.contains( chkStr ) )
        		{
        			String subHelps[] = helpItem.split( "\n" );
        			String item = "";
        		
        			for( X = 0; X < subHelps.length; X++ )
        			{
        				item = subHelps[X];
        				
        				if( item != "" )
        				{
    	    				try
    	    				{
    	    					who.sendMessage( parseHelpLine( who, item, topic ) );
    	    				}
    	    				catch (IOException e) 
    	    				{
    	    					who.sendMessage( cColour( "#!RUnable to load help file.#!w" ) );
    	    					e.printStackTrace();
    	    				}
        				}
        			}
        		}
    		}
    	}
    	
    	else
    	{
    		chkStr = "\n";
    	
    		if( helpData.contains( chkStr ) )
    		{
    			String[] helps = helpData.split( "\n" );
    			String item = "";
    		
    			for( int X = 0; X < helps.length; X++ )
    			{
    				item = helps[X];
    				
    				if( item != "" )
    				{
	    				try
	    				{
	    					who.sendMessage( parseHelpLine( who, item, topic ) );
	    				}
	    				catch (IOException e) 
	    				{
	    					who.sendMessage( cColour( "#!RUnable to load help file.#!w" ) );
	    					e.printStackTrace();
	    				}
    				}
    			}
    		}
    		else
    		{
    			who.sendMessage( parseHelpLine( who, helpData, topic ) );
    		}
    	}
    }

    public static String parseHelpLine( Player who, String helpLine, String topic ) throws IOException
    {
    	if( helpLine.length() < 5 )
    		return( cColour( helpLine ) );
    	
    	if( helpLine.substring(0,5).equals("[URL "))
		{
			String sub = helpLine.substring(5);
			String[] spl = null;
			
			if( sub.contains(" ]"))
			{
				spl = sub.split(" ]");
			}
			else if( sub.contains("]"))
			{
				spl = sub.split( "]");
			}
			else
			{	
				logOutput( "Error in URL string formatting for " + helpLine );
				return( cColour( "#!RThe help system encountered an error.#!w" ) );
			}
				
			return( parseHelpLine( who, fetchWebHelp(who.getDisplayName(), spl[0]), topic ) );
		}

		if( helpLine.substring(0,6).equals("[HELP "))
		{
			String sub = helpLine.substring(6);
			String[] spl = null;
			
			if( sub.contains(" ]"))
				spl = sub.split(" ]");
			else if( sub.contains("]"))
				spl = sub.split( "]");
			else
			{
				logOutput( "Error in redirector string formatting for " + helpLine );
				return( cColour( "#!RThe help system encountered an error.#!w" ) );
			}
			
			if( spl[0].compareTo(topic) == 0 )
			{
				logOutput( "Infinite loop detected in " + spl[0] + ".txt! Please fix it." );
				return( cColour( "#!RThe help system encountered an error.#!w" ) );
			}
			else
			{
				processHelp( who, getHelpFile( who, spl[0] ), topic );
				return( "" );
			}
		}		
		else
		{
			return( cColour( helpLine ) );
		}
    }
}
